# Matt Franklin
# Machine Learning + Sensing
# Assignment 3

import numpy as np
import cv2
import time


import serial # to talk to arduino
serialLink = serial.Serial('/dev/tty.usbmodem14301', 38400)


# change the number to select the right camera (often 1 or 0)
cap = cv2.VideoCapture(1)

count = 0

while(True):
    # grab a frame. (ret is just if it manages to grab a frame, so we ignore it in this case)
    ret, frame = cap.read()

    # the square to cut out of the middle that we care about
    square = 720 # 720 x 720

    frameH, frameW, frameC = frame.shape
    frameTop = int( (frameH-square) // 2)
    frameBottom = int(square + (frameH-square) // 2)
    frameLeft = int((frameW-square) //2)
    frameRight = int(square + (frameW-square) //2)
    cropped = frame[frameTop:frameBottom,frameLeft:frameRight,:]

    gray = cv2.cvtColor(cropped,cv2.COLOR_BGR2GRAY)
    ret, thresh = cv2.threshold(gray,40,255,cv2.THRESH_BINARY)
    shrunk = cv2.resize(thresh,(12,12))
    # shrunk = cv2.resize(thresh,(3,3))

    left = shrunk[:,:8]
    right = shrunk[:,-8:]
    top = shrunk[:8,:]
    bottom = shrunk[-8:,:]
    
    bumpleft = "0"
    bumpright = "0"
    bumptop = "0"
    bumpbottom = "0"

    # left = shrunk[:,:2]
    # right = shrunk[:,-2:]
    # top = shrunk[:2,:]
    # bottom = shrunk[-2:,:]

    leftval = np.mean(left)
    rightval = np.mean(right)
    topval = np.mean(top)
    bottomval = np.mean(bottom)
    


    keystroke = cv2.waitKey(1)
    if keystroke & 0xFF == ord('q'):
	    break
        # quit
    if keystroke & 0xFF == ord('p'):
        print(shrunk)
        print("left",leftval)
        print(left)
        print("right",rightval)
        print(right)
        print("top",topval)
        print(top)
        print("bottom", bottomval)
        print(bottom)
        cv2.waitKey(0)
        # pause
    
    # pull the cropped part up on screen
    # cv2.imshow('cropped',cropped)

    # pull the frame up on screen
    # cv2.imshow('frame',frame)

    # pull the shrunk up on screen
    # output = cv2.resize(shrunk,(720,720))
    output = thresh
    output = cv2.cvtColor(output, cv2.COLOR_GRAY2BGR)
    thresholdval = 220

    if(bottomval<thresholdval):
        bumpbottom = "1"
        output = cv2.putText(
                            output, 
                            "bottom", 
                            (360,680), 
                            cv2.FONT_HERSHEY_SIMPLEX,
                            1, 
                            (0,0,255), 
                            2, 
                            cv2.LINE_AA)
    if(topval<thresholdval):
        bumptop = "1"
        output = cv2.putText(
                            output, 
                            "top", 
                            (360,20), 
                            cv2.FONT_HERSHEY_SIMPLEX,
                            1, 
                            (0,0,255), 
                            2, 
                            cv2.LINE_AA)
    if(leftval<thresholdval):
        bumpleft = "1"
        output = cv2.putText(
                            output, 
                            "left", 
                            (20,360), 
                            cv2.FONT_HERSHEY_SIMPLEX,
                            1, 
                            (0,0,255), 
                            2, 
                            cv2.LINE_AA)
    if(rightval<thresholdval):
        bumpright = "1"
        output = cv2.putText(
                            output, 
                            "right", 
                            (640,360), 
                            cv2.FONT_HERSHEY_SIMPLEX,
                            1, 
                            (0,0,255), 
                            2, 
                            cv2.LINE_AA)

    cv2.imshow('output',output)

    # if(count>6)
    toserial = bumptop+bumpbottom+bumpleft+bumpright
    print(toserial)
    serialLink.write(str.encode(toserial))

    print(serialLink.read())
    # print(serialLink.read())
    # print(serialLink.read())
    # print(serialLink.read())

    # time.sleep(0.25)
    


    # pull the shrunk up on screen
    # cv2.imshow('threshold',thresh)

    

# When everything done, release the capture
cap.release()
cv2.destroyAllWindows()

